<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
    use Modules\Lpj\Models\Debiture;
    use Modules\Lpj\Models\HubunganPemilikJaminan;

    return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('pemilik_jaminan', function (Blueprint $table) {
            $table->id();
            $table->foreignIdFor(Debiture::class)->constrained('debitures')->onDelete('cascade');
            $table->foreignIdFor(HubunganPemilikJaminan::class)->constrained('hubungan_pemilik_jaminan')->onDelete('cascade');
            $table->string('name');
            $table->string('npwp', 16)->nullable();
            $table->string('nomor_id', 16)->nullable();
            $table->string('email', 100)->nullable();
            $table->string('phone', 15)->nullable();
            $table->string('province_code')->nullable()->index();
            $table->string('city_code')->nullable()->index();
            $table->string('district_code')->nullable()->index();
            $table->string('village_code')->nullable()->index();
            $table->string('postal_code', 5)->nullable();
            $table->text('address')->nullable();

            $table->boolean('status')->default(true)->nullable();
            $table->timestamps();
            $table->timestamp('authorized_at')->nullable();
            $table->char('authorized_status', 1)->nullable();
            $table->softDeletes();

            $table->unsignedBigInteger('created_by')->nullable();
            $table->unsignedBigInteger('updated_by')->nullable();
            $table->unsignedBigInteger('deleted_by')->nullable();
            $table->unsignedBigInteger('authorized_by')->nullable();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('pemilik_jaminan');
    }
};
